searchNodes=[{"ref":"Prestige.html","title":"Prestige","type":"module","doc":"An elixir client for Prestodb."},{"ref":"Prestige.html#execute/2","title":"Prestige.execute/2","type":"function","doc":"Executes a prepared statement against presto, returns a stream Options: :rows_as_maps - converts response to a list of maps, with the column name as the key and the row data as the value All other specified options are passed directly to presto as headers, a full list of those headers can be found here. Examples iex&gt; Prestige.execute(&quot;select * from users&quot;) |&gt; Prestige.prefetch [[1, &quot;Brian&quot;], [2, &quot;Shannon&quot;]] iex&gt; Prestige.execute(&quot;select * from users&quot;, rows_as_maps: true) |&gt; Prestige.prefetch [%{&quot;id&quot; =&gt; 1, &quot;name&quot; =&gt; &quot;Brian&quot;}, %{&quot;id&quot; =&gt; 2, &quot;name&quot; =&gt; &quot;Shannon&quot;}]"},{"ref":"Prestige.html#prefetch/1","title":"Prestige.prefetch/1","type":"function","doc":"Converts a presto stream into a map for consumption"},{"ref":"Prestige.Middleware.Retry.html","title":"Prestige.Middleware.Retry","type":"module","doc":"Tesla plug that will retry the http request when an error or 503 status code is returned. Will retry for a configurable amount of time Options: * `:max_retries` - Override amount of retry attempts (default: 5) * `:delay` - Delay between requests in milliseconds (default: 1000ms) Examples `plug(Prestige.Middleware.Retry, delay: 100, max_retries: 5)`"},{"ref":"Prestige.Middleware.Retry.html#call/3","title":"Prestige.Middleware.Retry.call/3","type":"function","doc":"Callback implementation for Tesla.Middleware.call/3."},{"ref":"Prestige.Result.html","title":"Prestige.Result","type":"module","doc":"Handles transforming result from presto into desired datastructure"},{"ref":"Prestige.Result.html#transform/2","title":"Prestige.Result.transform/2","type":"function","doc":"Transforms a successful presto select query into a map"},{"ref":"Prestige.Statement.html","title":"Prestige.Statement","type":"module","doc":"Handles the request response setup for presto"},{"ref":"Prestige.Statement.html#delete/3","title":"Prestige.Statement.delete/3","type":"function","doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete(&quot;/users&quot;) delete(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete(client, &quot;/users&quot;) delete(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#delete!/3","title":"Prestige.Statement.delete!/3","type":"function","doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete!(&quot;/users&quot;) delete!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete!(client, &quot;/users&quot;) delete!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#execute/2","title":"Prestige.Statement.execute/2","type":"function","doc":""},{"ref":"Prestige.Statement.html#get/3","title":"Prestige.Statement.get/3","type":"function","doc":"Perform a GET request. See request/1 or request/2 for options definition. get(&quot;/users&quot;) get(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get(client, &quot;/users&quot;) get(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#get!/3","title":"Prestige.Statement.get!/3","type":"function","doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get!(&quot;/users&quot;) get!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get!(client, &quot;/users&quot;) get!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#head/3","title":"Prestige.Statement.head/3","type":"function","doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head(&quot;/users&quot;) head(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head(client, &quot;/users&quot;) head(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#head!/3","title":"Prestige.Statement.head!/3","type":"function","doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head!(&quot;/users&quot;) head!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head!(client, &quot;/users&quot;) head!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#options/3","title":"Prestige.Statement.options/3","type":"function","doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options(&quot;/users&quot;) options(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options(client, &quot;/users&quot;) options(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#options!/3","title":"Prestige.Statement.options!/3","type":"function","doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options!(&quot;/users&quot;) options!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options!(client, &quot;/users&quot;) options!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#patch/4","title":"Prestige.Statement.patch/4","type":"function","doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#patch!/4","title":"Prestige.Statement.patch!/4","type":"function","doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#post/4","title":"Prestige.Statement.post/4","type":"function","doc":"Perform a POST request. See request/1 or request/2 for options definition. post(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#post!/4","title":"Prestige.Statement.post!/4","type":"function","doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#prefetch/1","title":"Prestige.Statement.prefetch/1","type":"function","doc":""},{"ref":"Prestige.Statement.html#put/4","title":"Prestige.Statement.put/4","type":"function","doc":"Perform a PUT request. See request/1 or request/2 for options definition. put(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#put!/4","title":"Prestige.Statement.put!/4","type":"function","doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#request/2","title":"Prestige.Statement.request/2","type":"function","doc":"Perform a request Options: :method - the request method, one of [:head, :get, :delete, :trace, :options, :post, :put, :patch] :url - either full url e.g. &quot;http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples: ExampleApi.request(method: :get, url: &quot;/users/path&quot;) You can also use shortcut methods like: ExampleApi.get(&quot;/users/1&quot;) or ExampleApi.post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;})"},{"ref":"Prestige.Statement.html#request!/2","title":"Prestige.Statement.request!/2","type":"function","doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options."},{"ref":"Prestige.Statement.html#trace/3","title":"Prestige.Statement.trace/3","type":"function","doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace(&quot;/users&quot;) trace(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace(client, &quot;/users&quot;) trace(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#trace!/3","title":"Prestige.Statement.trace!/3","type":"function","doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace!(&quot;/users&quot;) trace!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace!(client, &quot;/users&quot;) trace!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"Prestige.Statement.html#t:option/0","title":"Prestige.Statement.option/0","type":"type","doc":""},{"ref":"readme.html","title":"Prestige","type":"extras","doc":"Prestige A middleware layer for the Presto database Documentation: hexdocs"},{"ref":"readme.html#installation","title":"Prestige - Installation","type":"extras","doc":"Prestige can be installed by adding prestige to your list of dependencies in mix.exs: def deps do [ {:prestige, &quot;~&gt; 0.3.2&quot;} ] end"},{"ref":"readme.html#running-tests","title":"Prestige - Running tests","type":"extras","doc":"Clone the repo and fetch its dependencies: $ git clone https://github.com/smartcitiesdata/prestige $ cd prestige $ mix deps.get $ mix test"},{"ref":"readme.html#example-usage","title":"Prestige - Example Usage","type":"extras","doc":"Adding Data to Presto Create table: create_statement = &quot;create table memory.default.monkeys ( id bigint, stuff array(row(name varchar, color varchar)))&quot; Prestige.execute(create_statement, user: &quot;prestouser&quot;) |&gt; Stream.run() Insert data: insert_statement = &quot;insert into memory.default.monkeys(id, stuff) values(1, array[row(&#39;George&#39;,&#39;black&#39;), row(&#39;James&#39;,&#39;red&#39;)])&quot; Prestige.execute(insert_statement, user: &quot;prestouser&quot;) |&gt; Stream.run() Select data: iex&gt; Prestige.execute(&quot;select * from memory.default.monkeys&quot;, user: &quot;prestouser&quot;, by_names: true) |&gt; Prestige.prefetch [ %{ &quot;id&quot; =&gt; 1, &quot;stuff&quot; =&gt; [ %{&quot;color&quot; =&gt; &quot;black&quot;, &quot;name&quot; =&gt; &quot;George&quot;}, %{&quot;color&quot; =&gt; &quot;red&quot;, &quot;name&quot; =&gt; &quot;James&quot;} ] } ]"},{"ref":"readme.html#license","title":"Prestige - License","type":"extras","doc":"Released under Apache 2 license."}]